/**
 * @typedef { import("../types").Entity } Entity
 */

/**
 * Create a new in-world pile of gold
 * @param {number} x the x coordinate to create the gold item at
 * @param {number} y the y coordinate to create the gold item at
 * @param {number} value the number of gold to put at this position
 * @returns {Entity}
 */
export function createGoldItem(x, y, value) {
  return {
    position_component: {
      x: x,
      y: y,
    },
    on_contact_action_component: {
      range: 5,
      delete_on_touch: true,
      action: {
        type: 'gold',
        quantity: value,
      },
    },
    render_simple_square_component: {
      color: 'yellow',
      size: 10,
    },
  };
}
