/**
 * @typedef { import("../types").Entity } Entity
 */

/**
 * Create a new in-world stamina pickup
 * @param {number} x the x coordinate to create the stamina pickup item at
 * @param {number} y the y coordinate to create the stamina pickup item at
 * @param {number} value the number of stamina points to regenerate
 * @returns {Entity}
 */
export function createStaminaPickup(x, y, value) {
  return {
    position_component: {
      x: x,
      y: y,
    },
    on_contact_action_component: {
      range: 5,
      delete_on_touch: true,
      action: {
        type: 'stamina',
        quantity: value,
      },
    },
    render_simple_square_component: {
      color: 'green',
      size: 10,
    },
  };
}
