import { complexAIBehavior } from '../utils/ai/index.mjs';

/**
 * @typedef { import("../engine.mjs").Game } Game
 * @typedef { import("../types").Entity } Entity
 * @typedef { import("../types").AIState } AIState
 */

export function getBehaviorAIComplexSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function behaviorAIComplexSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.behavior_ai_component) continue;
      complexAIBehavior(game, entity, elapsedTicks);
    }
  };
}
