/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getControllerCameraSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function controllerCameraSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.controller_camera_component) continue;
      if (!entity.position_component) continue;
      if (!entity.controller_camera_component.camera_follows_entity) continue;

      game.mapData.offsetX = Math.min(
        game.mapData.tiles.content[0].length * game.mapData.tiles.tile_width - game.mapData.render_width,
        Math.max(0, entity.position_component.x - game.mapData.render_width / 2)
      );
      game.mapData.offsetY = Math.min(
        game.mapData.tiles.content.length * game.mapData.tiles.tile_height - game.mapData.render_height,
        Math.max(0, entity.position_component.y - game.mapData.render_height / 2)
      );
    }
  };
}
