/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getControllerDoorCollisionSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function controllerDoorCollisionSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.controller_door_component) continue;
      if (!entity.collision_component) continue;
      entity.collision_component.is_enabled = !entity.controller_door_component.is_opened;
    }
  };
}
