/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getControllerStaminaRegenSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function controllerStaminaRegenSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.controller_stamina_regen_component) continue;
      if (!entity.stamina_component) continue;
      entity.controller_stamina_regen_component.stamina_regen_cooldown -= elapsedTicks;
      if (entity.controller_stamina_regen_component.stamina_regen_cooldown < 0)
        entity.controller_stamina_regen_component.stamina_regen_cooldown = 0;
      if (!entity.controller_stamina_regen_component.stamina_regen_cooldown)
        entity.stamina_component.stamina +=
          elapsedTicks * entity.controller_stamina_regen_component.stamina_regen_quantity_per_tick;
      if (entity.stamina_component.stamina > entity.stamina_component.max_stamina)
        entity.stamina_component.stamina = entity.stamina_component.max_stamina;
    }
  };
}
