/**
 * @typedef { import("../engine.mjs").Game } Game
 */

/**
 * @param {{ [key: string]: ImageBitmap }} images The loaded images to use by the renderer
 */
export function getHudFacesetSystem(images) {
  /**
   * @param {Game} game The current game
   */
  return function hudFacesetSystem(game) {
    for (const entity of game.entities) {
      if (!entity.render_hud_component) continue;
      if (!entity.render_hud_component.enable_faceset) continue;
      if (!entity.faceset_component) continue;
      game.context.fillStyle = 'rgba(0.5, 0.5, 0.5, 0.5)';
      game.context.fillRect(0, 430, 130, 170);

      let filepath = entity.faceset_component.image;
      if (!images[filepath]) filepath = entity.faceset_component.default;
      game.context.drawImage(images[filepath], 10, 445, 110, 150);
    }
  };
}
