/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getHudFpsSystem() {
  /**
   * @param {Game} game
   */
  return function hudFpsSystem(game) {
    if (!game.showMetaText) return;
    const metaText =
      `FPS: ${Math.floor(game.fps)}` +
      ` /// ` +
      `Mouse: ${game.mouse.x} ; ${game.mouse.y} P:${game.mouse.primary_button} S:${game.mouse.secondary_button}`;
    game.context.textAlign = 'start';
    game.context.font = '12px sans-serif';
    const meta_width = game.context.measureText(metaText).width;
    game.context.fillStyle = 'rgba(0.5, 0.5, 0.5, 0.5)';
    game.context.fillRect(790 - meta_width, 0, meta_width + 10, 20);
    game.context.fillStyle = 'white';
    game.context.strokeStyle = 'transparent';
    game.context.fillText(metaText, 795 - meta_width, 15);
  };
}
