/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getHudPlayerStatusSystem() {
  /**
   * @param {Game} game The current game
   */
  return function hudPlayerStatusSystem(game) {
    for (const entity of game.entities) {
      if (!entity.render_hud_component) continue;
      if (!entity.render_hud_component.enable_status) continue;
      if (!entity.stamina_component) continue;
      game.context.fillStyle = 'rgba(0.5, 0.5, 0.5, 0.5)';
      game.context.fillRect(150, 500, 200, 100);

      // Draw the player's stamina
      const STAMINA_BAR_X = 150;
      const STAMINA_BAR_Y = 15;
      game.context.fillStyle = 'grey';
      game.context.fillRect(168, 538, STAMINA_BAR_X + 4, STAMINA_BAR_Y + 4);
      game.context.fillStyle = 'white';
      game.context.fillRect(170, 540, STAMINA_BAR_X, STAMINA_BAR_Y);
      const bar_progress_px = (STAMINA_BAR_X * entity.stamina_component.stamina) / entity.stamina_component.max_stamina;
      game.context.fillStyle = 'green';
      game.context.fillRect(170, 540, bar_progress_px, STAMINA_BAR_Y);
      game.context.font = '12px sans-serif';
      game.context.fillStyle = 'black';
      game.context.fillText(
        'Stamina: ' +
          Math.floor(entity.stamina_component.stamina) +
          ' / ' +
          Math.floor(entity.stamina_component.max_stamina),
        175,
        552
      );
    }
  };
}
