/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getRenderAngleSystem() {
  /**
   * @param {Game} game
   */
  return function renderAngleSystem(game) {
    for (const entity of game.entities) {
      if (!entity.angle_component) continue;
      if (!entity.position_component) continue;
      const centerOffsetX = -15 * Math.cos(entity.angle_component.angle);
      const centerOffsetY = -15 * Math.sin(entity.angle_component.angle);
      game.renderer.renderWorldCircle(
        entity.position_component.x + centerOffsetX,
        entity.position_component.y + centerOffsetY,
        5,
        'green'
      );
    }
  };
}
