import { GAME_SPRITE_SIDE } from '../loader/assets.mjs';

/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getRenderBlindfoldSystem() {
  /**
   * @param {Game} game The current game
   */
  return function renderBlindfoldSystem(game) {
    for (const entity of game.entities) {
      if (!entity.render_blindfold_component) continue;
      if (!entity.position_component) continue;
      if (!entity.render_blindfold_component.blindfold_enabled) continue;
      let rectStartX =
        entity.position_component.x -
        GAME_SPRITE_SIDE * entity.render_blindfold_component.visible_tiles_around -
        game.mapData.offsetX;
      let rectStartY =
        entity.position_component.y -
        GAME_SPRITE_SIDE * entity.render_blindfold_component.visible_tiles_around -
        game.mapData.offsetY;
      game.context.fillStyle = 'black';
      game.context.strokeStyle = 'transparent';
      game.context.fillRect(0, 0, 800, rectStartY);
      game.context.fillRect(0, 0, rectStartX, 600);
      game.context.fillRect(
        rectStartX + GAME_SPRITE_SIDE * entity.render_blindfold_component.visible_tiles_around * 2,
        0,
        800,
        600
      );
      game.context.fillRect(
        0,
        rectStartY + GAME_SPRITE_SIDE * entity.render_blindfold_component.visible_tiles_around * 2,
        800,
        600
      );
    }
  };
}
