/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getRenderSimpleSquareSystem() {
  /**
   * @param {Game} game
   */
  return function renderSimpleSquareSystem(game) {
    for (const entity of game.entities) {
      if (!entity.render_simple_square_component) continue;
      if (!entity.position_component) continue;
      game.renderer.renderWorldRect(
        entity.position_component.x - entity.render_simple_square_component.size / 2,
        entity.position_component.y - entity.render_simple_square_component.size / 2,
        entity.render_simple_square_component.size,
        entity.render_simple_square_component.size,
        entity.render_simple_square_component.color
      );
    }
  };
}
