/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getSpriteControllerBasicEnemySystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function spritecontrollerBasicEnemySystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.sprite_controller_enemy_basic_component) continue;
      if (!entity.render_simple_sprite_component) continue;

      if (entity.contained_component) {
        entity.sprite_controller_enemy_basic_component.is_displayed = !entity.contained_component.is_inside_container;
      }

      if (entity.angle_component) {
        /** @type {typeof entity.sprite_controller_enemy_basic_component.direction} */
        let direction = 'right';
        let estAngle = entity.angle_component.angle;
        if (estAngle > Math.PI * (7 / 4)) direction = 'right';
        else if (estAngle > Math.PI * (5 / 4)) direction = 'down';
        else if (estAngle > Math.PI * (3 / 4)) direction = 'left';
        else if (estAngle > Math.PI * (1 / 4)) direction = 'up';
        entity.sprite_controller_enemy_basic_component.direction = direction;
      }

      let sprite_suffix = {
        up: 'u',
        down: 'd',
        left: 'l',
        right: 'r',
      }[entity.sprite_controller_enemy_basic_component.direction];

      entity.render_simple_sprite_component.is_displayed = entity.sprite_controller_enemy_basic_component.is_displayed;
      entity.render_simple_sprite_component.sprite =
        entity.sprite_controller_enemy_basic_component.sprite_prefix + '_' + sprite_suffix;
    }
  };
}
