/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getSpriteControllerDoorSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function spriteControllerDoorSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.controller_door_component) continue;
      if (!entity.render_simple_sprite_component) continue;

      if (entity.controller_door_component.is_opened) {
        entity.render_simple_sprite_component.sprite = entity.controller_door_component.sprite_opened;
      } else {
        entity.render_simple_sprite_component.sprite = entity.controller_door_component.sprite_closed;
      }
    }
  };
}
