/**
 * @typedef { import("../engine.mjs").Game } Game
 */

export function getSpriteControllerMimicSystem() {
  /**
   * @param {Game} game
   * @param {number} elapsedTicks
   */
  return function spriteControllerMimicSystem(game, elapsedTicks) {
    for (const entity of game.entities) {
      if (!entity.sprite_controller_mimic_component) continue;
      if (!entity.behavior_ai_mimic_component) continue;
      if (!entity.render_simple_sprite_component) continue;
      /** @type {typeof entity.sprite_controller_mimic_component.status} */
      let direction_override = 'idle';
      let animated_sprite_index = Math.floor(entity.behavior_ai_mimic_component.animation_cycle / 4);
      if (entity.behavior_ai_mimic_component.state === 'spitting') direction_override = 'attack1';
      if (entity.behavior_ai_mimic_component.state === 'grabbing' && animated_sprite_index % 2 === 0)
        direction_override = 'attack1';
      if (entity.behavior_ai_mimic_component.state === 'grabbing' && animated_sprite_index % 2 === 1)
        direction_override = 'attack2';
      if (entity.behavior_ai_mimic_component.state === 'eating' && animated_sprite_index % 2 === 0)
        direction_override = 'digest1';
      if (entity.behavior_ai_mimic_component.state === 'eating' && animated_sprite_index % 2 === 1)
        direction_override = 'digest2';
      entity.sprite_controller_mimic_component.is_displayed = true;
      entity.sprite_controller_mimic_component.status = direction_override;

      entity.render_simple_sprite_component.sprite =
        entity.sprite_controller_mimic_component.sprite_prefix + '_' + entity.sprite_controller_mimic_component.status;
    }
  };
}
