const path = require('path');
const fs = require('fs');

try {
  fs.rmSync('dist', { force: true, recursive: true });
} catch (e) {
  console.warn(e);
  /* NO OP*/
}

fs.mkdirSync('dist');

function copyFolderSync(sourceFolder, parentTarget) {
  const targetFolder = path.join(parentTarget, path.basename(sourceFolder));
  try {
    fs.mkdirSync(targetFolder);
  } catch {
    /* NO OP */
  }

  for (const sourceName of fs.readdirSync(sourceFolder)) {
    const sourceFileOrFolder = path.join(sourceFolder, sourceName);
    if (fs.lstatSync(sourceFileOrFolder).isDirectory()) {
      copyFolderSync(sourceFileOrFolder, targetFolder);
      continue;
    }

    const newFile = path.join(targetFolder, sourceName);
    try {
      fs.copyFileSync(sourceFileOrFolder, newFile);
    } catch {
      /* NO OP */
    }
  }
}

copyFolderSync('assets', 'dist');
copyFolderSync('code', 'dist');
try {
  fs.copyFileSync('index.html', 'dist/index.html');
} catch {
  /* NO OP */
}
